package com.muyu.cloud.etl.mysql;


import com.muyu.Hikari.HikariPool;
import com.muyu.cloud.etl.service.SourceService;
import com.muyu.common.core.utils.SpringUtils;
import com.muyu.data.base.BaseDataAbsSource;
import com.muyu.domain.DataValue;
import com.muyu.domain.Source;
import com.muyu.domain.enums.DataType;
import com.zaxxer.hikari.HikariDataSource;
import lombok.extern.log4j.Log4j2;
import org.springframework.stereotype.Component;

import java.sql.*;
import java.util.concurrent.ConcurrentHashMap;


@Log4j2
@Component
public class MySqlDataSource extends BaseDataAbsSource {


    SourceService sourceService = SpringUtils.getBean(SourceService.class);


    @Override
    public DataValue getDataValue() {

        return null;
    }

    @Override
    public DataValue[] getRow () {
//        MySqlQuery query = getQuery();
//        String sql = query.getSql();
//        Long dataSourceId = query.getDataSourceId();
//        ConcurrentHashMap<Integer, DataValue> map = new ConcurrentHashMap<>();
//        Source dataSources = sourceService.getById(dataSourceId);
//        MysqlPoolConfig mysqlPoolConfig = Source.getMysqlPoolConfig(dataSources);
//
//        MysqlPool mysqlPool = new MysqlPool(mysqlPoolConfig);
//        mysqlPool.init();
//        Connection conn = mysqlPool.getConn();
//
//        DataValue[] dataValues = null;
//
//        try {
//            PreparedStatement preparedStatement = conn.prepareStatement(sql);
//            ResultSet resultSet = preparedStatement.executeQuery();
//            ResultSetMetaData metaData = resultSet.getMetaData();
//            int columnCount = metaData.getColumnCount();
//            if (resultSet.next()){
//                for (int i = 1; i < columnCount; i++) {
//                    if (resultSet.isFirst()){
//                        String columnTypeName = metaData.getColumnTypeName(i);
//                        DatabaseMetaData metadataColumns = conn.getMetaData();
//                        ResultSet columns = metadataColumns.getColumns(null, null, metaData.getTableName(i), metaData.getColumnName(i));
//                        String remarks =null;
//                        while (columns.next()){
//                            remarks = columns.getString("REMARKS");
//                            log.info("字段备注:"+remarks);
//                        }
//                        DataValue build = DataValue.builder()
//                                .key(metaData.getColumnName(i))
//                                .label(remarks)
//                                .value(resultSet.getObject(i, DataType.convertType(columnTypeName)))
//                                .type(DataType.findBySqlType(columnTypeName))
//                                .build();
//                        map.put(i,build);
//                        dataValues[i-1]=build;
//                    }
//                }
//            }
//
//
//        } catch (SQLException e) {
//            throw new RuntimeException(e);
//        }
        return null;
    }

    @Override
    public DataValue[][] getRows () {
        MySqlQuery query = getQuery();
        Integer one = Math.toIntExact(query.getOne());
        Integer two = query.getTwo();
        String sql = query.getSql();
        Long dataSourceId = query.getDataSourceId();
        ConcurrentHashMap<Integer, DataValue> map = new ConcurrentHashMap<>();
        Source dataSources = sourceService.getById(dataSourceId);

        HikariDataSource hikariDataSource = HikariPool.getHikariDataSource(dataSources);

        Connection  conn = null;
//        try {
//
//        } catch (SQLException e) {
//            throw new RuntimeException(e);
//        }
        log.info("one------------"+one+"------------two"+two);
        DataValue[][] dataValues = new DataValue[one][two];
        try {
            conn = hikariDataSource.getConnection();

            PreparedStatement preparedStatement = conn.prepareStatement(sql);
            ResultSet resultSet = preparedStatement.executeQuery();
            ResultSetMetaData metaData = resultSet.getMetaData();
            int columnCount = metaData.getColumnCount();
            int c = 0;
            while (resultSet.next()){
                for (int i = 1; i <= columnCount; i++) {
                    if (resultSet.isFirst()){
                        String columnTypeName = metaData.getColumnTypeName(i);
                        DatabaseMetaData metaDataColumns = conn.getMetaData();
                        ResultSet columns = metaDataColumns.getColumns(null, null, metaData.getTableName(i), metaData.getColumnName(i));
                        String remarks =null;

                        while (columns.next()){
                            remarks = columns.getString("REMARKS");

                            log.info("字段备注:"+remarks);
                        }
                        DataValue build = DataValue.builder()
                                .key(metaData.getColumnName(i))
                                .label(remarks)
                                .value(resultSet.getObject(i, DataType.convertType(columnTypeName)))
                                .type(DataType.findBySqlType(columnTypeName))
                                .build();
                        map.put(i,build);
                        dataValues[c][i-1]=build;
                    }else {
                        DataValue build = DataValue.builder()
                                .key(metaData.getColumnName(i))
                                .label(map.get(i).getLabel())
                                .value(resultSet.getObject(i, map.get(i).getType().getTargetType()))
                                .type(map.get(i).getType())
                                .build();
                        dataValues[c][i-1]=build;
                    }
                }
                c++;
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        }finally {
            close(hikariDataSource);
        }

        return dataValues;
    }
    private static void close(HikariDataSource dataSource) {
        if (dataSource != null) {
            dataSource.close();
        }
    }
}
